{*> Ver: Beta V1.0b1 *********      History      ***************************\

Beta V1.0b0		04/29/1999		Released
Beta V1.0b1		05/24/1999		The Synchro method editors have been added. 

Legal issues: Copyright (C) 1999 by Boian Mitov
              <mitov@ec.rockwell.com>
              <http://members.xoom.com/mitov>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

\***************************************************************************}
unit BMDThread;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Syncobjs, Extctrls, Dsgnintf, TypInfo,
  ComCtrls, StdCtrls, Buttons, Clipbrd, ExptIntf, EditIntf, ToolIntf;

type
  TEventsEditorNotification   = class;
  
  TSynchroMethodsForm = class(TForm)
    PageControl: TPageControl;
    ThreadSynchroTabSheet: TTabSheet;
    ThreadEventsListView: TListView;
    Panel1: TPanel;
    CreateGroupBox: TGroupBox;
    BtnNoDataEvent: TBitBtn;
    BtnDataEvent: TBitBtn;
    RenameButton1: TBitBtn;
    ShowButton1: TBitBtn;
    Panel3: TPanel;
    CopyCallButton1: TBitBtn;
    GenCallButton1: TBitBtn;
    RefreshButton1: TBitBtn;
    TabSheet2: TTabSheet;
    StdEventsListView: TListView;
    Panel2: TPanel;
    NewStdButton: TBitBtn;
    RenameButton2: TBitBtn;
    ShowButton2: TBitBtn;
    Panel4: TPanel;
    CopyCallButton2: TBitBtn;
    GenCallButton2: TBitBtn;
    RefreshButton2: TBitBtn;
    StatusBar: TStatusBar;
    Timer1: TTimer;
    procedure PageControlChange(Sender: TObject);
    procedure RefreshButton1Click(Sender: TObject);
    procedure BtnNoDataEventClick(Sender: TObject);
    procedure BtnDataEventClick(Sender: TObject);
    procedure RenameButton1Click(Sender: TObject);
    procedure ShowButton1Click(Sender: TObject);
    procedure CopyCallButton1Click(Sender: TObject);
    procedure GenCallButton1Click(Sender: TObject);
    procedure NewStdButtonClick(Sender: TObject);
    procedure ThreadEventsListViewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure ThreadEventsListViewEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure ThreadEventsListViewKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }

  protected
    Designer : IFormDesigner;
    UpdateNotifier : TEventsEditorNotification;
    ActiveListView   : TListView;
    ThreadEventsList : TStringList;
    StdEventsList    : TStringList;

  protected
    procedure AddMethodNoDataEntry ( const S: string );
    procedure AddMethodDataEntry ( const S: string );
    procedure AddStandardNotifyEntry ( const S: string );
    function AddMethodNoDataItem ( const S: string ) : TListItem;
    function AddMethodDataItem ( const S: string ) : TListItem;
    function AddStandardNotifyItem ( const S: string ) : TListItem;
    procedure ValidateComponents;
    procedure UpdateView;
    procedure ClearLists;
    procedure OnFileNotify  (  NotifyCode : TFileNotification; const FileName: string; var Cancel : boolean );
    procedure OnEventNotify ( NotifyCode : TEventNotification; var Cancel : boolean );

  public
    { Public declarations }
    procedure SetDesigner ( _Designer : IFormDesigner );   

  public
    constructor Create(AOwner: TComponent; _Designer : IFormDesigner ); overload;
    destructor Destroy; override;

  end;

{ Forward class declarations }
  TBMDThread                  = class;
  TBMDExecuteThread           = class;
  TBMDThreadGroup             = class;

{ Thread events }
  TBMDThreadNotifyEvent             = procedure(Sender: TObject; Thread : TBMDExecuteThread ) of object;
  TBMDThreadDataNotifyEvent         = procedure(Sender: TObject; Thread : TBMDExecuteThread; var Data : Pointer ) of object;
  TBMDThreadUpdateNotifyEvent       = procedure(Sender: TObject; Thread : TBMDExecuteThread; var Data : Pointer; Percent : Integer ) of object;
  TBMDThreadSynchroNotifyEvent      = procedure(Sender: TBMDThread; Thread : TBMDExecuteThread ) of object;
  TBMDThreadSynchroDataNotifyEvent  = procedure(Sender: TBMDThread; Thread : TBMDExecuteThread; var Data : Pointer ) of object;

  TFileNotifyEvent                  = procedure( NotifyCode : TFileNotification; const FileName: string; var Cancel : boolean ) of object;
  TEventNotifyEvent                 = procedure( NotifyCode : TEventNotification; var Cancel : boolean ) of object;

{ TBMDExecuteThread class }
TBMDExecuteThread = class(TThread)
  private
    { Private declarations }

  protected
    { Protected declarations }
    ThreadOwner : TBMDThread;

  protected
    { Protected declarations }
    FData                      : Pointer;
    FNotifyEvent               : TNotifyEvent;
    FThreadNotifyEvent         : TBMDThreadSynchroNotifyEvent;
    FThreadDataNotifyEvent     : TBMDThreadSynchroDataNotifyEvent;

    UpdateData                 : Pointer;

  public
    { Public declarations }
    PercentProgress            : Integer;

  public
    procedure DoNotifySynchro;
    procedure DoThreadNotifySynchro;
    procedure DoThreadNotifySynchroData;

    procedure Synchronize ( SynchroEvent : TNotifyEvent );                                     overload;
    procedure Synchronize ( SynchroEvent : TBMDThreadSynchroNotifyEvent );                     overload;
    procedure Synchronize ( SynchroEvent : TBMDThreadSynchroDataNotifyEvent; Data : Pointer ); overload;
// The folowing two functions are obsolete and should not be used in future !!!
// Obsolete !!! Don't use any mote !!! >>>>
    procedure Synchronize ( SynchroEvent : TBMDThreadNotifyEvent );                            overload;
    procedure Synchronize ( SynchroEvent : TBMDThreadDataNotifyEvent; Data : Pointer );        overload;
// <<< Obsolete !!! Don't use any mote !!!

  protected
    procedure Execute(); override;

  public
    constructor Create ( _ThreadOwner : TBMDThread; _UpdateData : Pointer ); virtual;

  public
    property Terminated;

  end;

{ TBMDThread class }
TBMDThreadBase = class(TComponent)
  private
    FOnUpdate                   : TBMDThreadUpdateNotifyEvent;
    FOnStart                    : TBMDThreadDataNotifyEvent;
    FOnTerminate                : TBMDThreadDataNotifyEvent;

    FThreadGroup                : TBMDThreadGroup;

    FUpdatePriority             : Integer;

  protected
    UpdateCriticalSection       : TCriticalSection;

  public
    constructor Create ( Owner :TComponent ); override;
    destructor Destroy; override;

  protected
    function GetRuning () : boolean; virtual; abstract;

    procedure SetThreadGroup ( _ThreadGroup :TBMDThreadGroup );

  protected
    procedure ReportStarted ( ThreadGroup :TBMDThreadGroup ); virtual; abstract;
    procedure ReportTerminated ( ThreadGroup :TBMDThreadGroup ); virtual; abstract;
    procedure AddMe ( ThreadGroup :TBMDThreadGroup ); virtual; abstract;
    procedure RemoveMe ( ThreadGroup :TBMDThreadGroup ); virtual; abstract;

  public
    procedure Start (); overload; virtual; abstract;
    procedure Start ( Data : Pointer ); overload; virtual; abstract;
    procedure Stop (); virtual; abstract;

    procedure Suspend (); virtual; abstract;
    procedure Resume (); virtual; abstract;

  public
    property Runing:              boolean          read GetRuning;
    property ThreadGroup:         TBMDThreadGroup  read FThreadGroup       write SetThreadGroup;
    property UpdatePriority:      integer          read FUpdatePriority    write FUpdatePriority default 0;

    property OnUpdate:            TBMDThreadUpdateNotifyEvent   read FOnUpdate write FOnUpdate;
    property OnStart:             TBMDThreadDataNotifyEvent     read FOnStart write FOnStart;
    property OnTerminate:         TBMDThreadDataNotifyEvent     read FOnTerminate write FOnTerminate;

  end;

{ TBMDThread class }
TBMDThread = class(TBMDThreadBase)
  protected
    FUpdateTimer              : TTimer;
    FOnExecute                : TBMDThreadDataNotifyEvent;
    FExecuteThread            : TBMDExecuteThread;
    FPriority                 : TThreadPriority;

    FInterrupted              : boolean;

  protected
    procedure OnUpdateTimer ( Sender : TObject ); virtual;
    procedure Execute(); virtual;

    procedure OnThreadTerminate ( Sender : TObject  ); virtual;
    procedure OnThreadTerminateClose ( Sender : TObject ); virtual;

    procedure ReportStarted ( ThreadGroup :TBMDThreadGroup ); override;
    procedure ReportTerminated ( ThreadGroup :TBMDThreadGroup ); override;
    procedure AddMe ( ThreadGroup :TBMDThreadGroup ); override;
    procedure RemoveMe ( ThreadGroup :TBMDThreadGroup ); override;

  protected
    procedure SetTimeInterval ( TimeInterval : Cardinal );
    function GetTimeInterval () : Cardinal;

    procedure SetPriority ( Value : TThreadPriority );
    function GetPriority () : TThreadPriority;

    function GetRuning () : boolean; override;
    function GetEmptyEntry () : TPersistent;

  public
    constructor Create ( Owner :TComponent ); override;
    destructor Destroy; override;

  public
    procedure Start (); overload; override;
    procedure Start ( Data : Pointer ); overload; override;
    procedure Stop (); override;

    procedure Suspend (); override;
    procedure Resume (); override;

  public
    property Runing;
    property Interrupted: boolean       read FInterrupted;
    property Thread :TBMDExecuteThread  read FExecuteThread;

  published
    property RefreshInterval: Cardinal         read GetTimeInterval write SetTimeInterval default 100;
    property Priority:        TThreadPriority  read GetPriority write SetPriority default tpNormal;
    property ThreadGroup;
    property UpdatePriority;

    property SynchroMethods : TPersistent read GetEmptyEntry;

    property OnExecute:       TBMDThreadDataNotifyEvent  read FOnExecute write FOnExecute;
    property OnUpdate;
    property OnStart;
    property OnTerminate;
  end;

  TBMDThreadGroup = class(TBMDThreadBase)
  protected
    ThreadItemsList : TList;
    ThreadsList     : TList;

  protected
    FOnThreadUpdate             : TBMDThreadUpdateNotifyEvent;
    FOnThreadStart              : TBMDThreadDataNotifyEvent;
    FOnThreadTerminate          : TBMDThreadDataNotifyEvent;


//---------------------------------------------------------------------------
// Protected by CriticalSection
    FCountRuning               : Integer;
//---------------------------------------------------------------------------

  protected
    function GetRuning () : boolean; override;
    function GetCountRuning () : Integer; virtual;

    function GetThreadItemsCount () : Integer;
    function GetThreadItems ( Index : Integer ) : TBMDThreadBase;

    function GetThreadsCount () : Integer;
    function GetThreads ( Index : Integer ) : TBMDThread;

  protected
    procedure ReportStarted ( ThreadGroup :TBMDThreadGroup ); override;
    procedure ReportTerminated ( ThreadGroup :TBMDThreadGroup ); override;
    procedure AddMe ( ThreadGroup :TBMDThreadGroup ); override;
    procedure RemoveMe ( ThreadGroup :TBMDThreadGroup ); override;

  public
    constructor Create ( Owner :TComponent ); override;
    destructor Destroy; override;

  public
    procedure Start (); overload; override;
    procedure Start ( Data : Pointer ); overload; override;
    procedure Stop (); override;

    procedure Suspend (); override;
    procedure Resume (); override;

  public
    procedure AddThread ( _Thread : TBMDThread );
    procedure RemoveThread ( _Thread : TBMDThread );

    procedure AddThreadGroup ( _ThreadGroup : TBMDThreadGroup );
    procedure RemoveThreadGroup ( _ThreadGroup : TBMDThreadGroup );

  public
    procedure ThreadStarted ( Sender : TObject; Thread : TBMDExecuteThread; var Data : Pointer );
    procedure ThreadUpdate ( Sender : TObject; Thread : TBMDExecuteThread; var Data : Pointer; _UpdatePriority : Integer; PercentProgres : Integer );
    procedure ThreadTerminated ( Sender : TObject; Thread : TBMDExecuteThread; var Data : Pointer );

  public
    property Runing;
    property CountRuning : Integer read GetCountRuning;

    property ThreadItemsCount : Integer read GetThreadItemsCount;
    property ThreadItems [Index: Integer]: TBMDThreadBase read  GetThreadItems;

    property ThreadsCount : Integer read GetThreadsCount;
    property Threads [Index: Integer] : TBMDThread read GetThreads;

  published
    property ThreadGroup;
    property UpdatePriority;

    property OnUpdate;
    property OnStart;
    property OnTerminate;

    property OnThreadUpdate    : TBMDThreadUpdateNotifyEvent read FOnThreadUpdate    write FOnThreadUpdate;
    property OnThreadStart     : TBMDThreadDataNotifyEvent   read FOnThreadStart     write FOnThreadStart;
    property OnThreadTerminate : TBMDThreadDataNotifyEvent   read FOnThreadTerminate write FOnThreadTerminate;
  end;
//---------------------------------------------------------------------------
TBMDThreadControlEditor = class ( TComponentEditor )
public
    destructor Destroy; override;
    
    procedure Edit; override;
    procedure ExecuteVerb ( Index : integer ); override;
    function GetVerb( Index : integer ) : string; override;
    function GetVerbCount () : integer; override;
end;
//---------------------------------------------------------------------------
TEmptyEntryPropertyEditor = class(TPropertyEditor)
    function GetValue: string; override;
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

TEventsEditorNotification = class ( TIAddInNotifier )
public
  FOnFileNotify  : TFileNotifyEvent;
  FOnEventNotify : TEventNotifyEvent;

public
    procedure FileNotification(NotifyCode: TFileNotification; const FileName: string; var Cancel: Boolean); override; stdcall;
    procedure EventNotification(NotifyCode: TEventNotification; var Cancel: Boolean); override; stdcall;

public
{
	inline __fastcall TEventsEditorNotification (void)
          ToolServices->AddNotifierEx ( this );
}
public
{	inline __fastcall virtual ~TEventsEditorNotification(void)
          ToolServices->RemoveNotifier ( this );
}
end;

procedure Register;


implementation
{$R *.DFM}

type
TThreadEventSruct = class ( TObject )
public
  Parameter       : string;
  CallingFormat   : string;
  end;

//---------------------------------------------------------------------------

var
  DesignForm : TSynchroMethodsForm;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
procedure TEventsEditorNotification.FileNotification(NotifyCode: TFileNotification; const FileName: string; var Cancel: Boolean);
begin
  if ( Assigned ( FOnFileNotify )) then
    FOnFileNotify ( NotifyCode, FileName, Cancel );
end;
//---------------------------------------------------------------------------
procedure TEventsEditorNotification.EventNotification(NotifyCode: TEventNotification; var Cancel: Boolean);
begin
  if ( Assigned ( FOnEventNotify )) then
    FOnEventNotify ( NotifyCode, Cancel );
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
constructor TBMDExecuteThread.Create ( _ThreadOwner : TBMDThread; _UpdateData : Pointer );
begin
  inherited Create (True);
  ThreadOwner := _ThreadOwner;
  UpdateData := _UpdateData;

  OnTerminate := ThreadOwner.OnThreadTerminate;
  FreeOnTerminate := True;
  Priority := ThreadOwner.FPriority;

  PercentProgress := 0;
end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.DoNotifySynchro;
begin
  if ( Assigned(FNotifyEvent) ) then
    FNotifyEvent ( ThreadOwner );

end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.DoThreadNotifySynchro;
begin
  if ( Assigned(FThreadNotifyEvent) ) then
    FThreadNotifyEvent ( ThreadOwner, Self );

end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.DoThreadNotifySynchroData;
begin
  if ( Assigned(FThreadDataNotifyEvent) ) then
    FThreadDataNotifyEvent ( ThreadOwner, Self, FData );

end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.Synchronize ( SynchroEvent : TNotifyEvent );
begin
  if ( Terminated ) then
    exit;

  if ( not Assigned ( SynchroEvent) ) then
    exit;

  FNotifyEvent := SynchroEvent;
  inherited Synchronize ( DoNotifySynchro );

end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.Synchronize ( SynchroEvent : TBMDThreadSynchroNotifyEvent );
begin
  if ( Terminated ) then
    exit;

  if ( not Assigned ( SynchroEvent) ) then
    exit;

  FThreadNotifyEvent := SynchroEvent;
  inherited Synchronize ( DoThreadNotifySynchro );
end;
//---------------------------------------------------------------------------
// The folowing two functions are obsolete and should not be used in future !!!
// Obsolete !!! Don't use any mote !!! >>>>
procedure TBMDExecuteThread.Synchronize ( SynchroEvent : TBMDThreadNotifyEvent );
begin
  Synchronize ( TBMDThreadSynchroNotifyEvent ( SynchroEvent ) );
end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.Synchronize ( SynchroEvent : TBMDThreadDataNotifyEvent; Data : Pointer );
begin
  Synchronize ( TBMDThreadSynchroDataNotifyEvent ( SynchroEvent ), Data );
end;
// <<< Obsolete !!! Don't use any mote !!!
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.Synchronize ( SynchroEvent : TBMDThreadSynchroDataNotifyEvent; Data : Pointer );
begin
  if ( Terminated ) then
    exit;

  if ( not Assigned ( SynchroEvent) ) then
    exit;

  FThreadDataNotifyEvent := SynchroEvent;
  FData := Data;
  inherited Synchronize ( DoThreadNotifySynchroData );
end;
//---------------------------------------------------------------------------
procedure TBMDExecuteThread.Execute();
begin
  ThreadOwner.Execute ();
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
constructor TBMDThreadBase.Create ( Owner :TComponent );
begin
  inherited;
  FUpdatePriority := 0;
  FThreadGroup := NIL;
  UpdateCriticalSection := TCriticalSection.Create;
end;
//---------------------------------------------------------------------------
destructor TBMDThreadBase.Destroy;
begin
  SetThreadGroup ( NIL );
  UpdateCriticalSection.Free;
  inherited;
end;
//---------------------------------------------------------------------------
procedure TBMDThreadBase.SetThreadGroup ( _ThreadGroup :TBMDThreadGroup );
begin
  if ( _ThreadGroup = FThreadGroup ) then
    exit;

  if ( FThreadGroup <> NIL ) then
    RemoveMe ( FThreadGroup );

  FThreadGroup := _ThreadGroup;

  if ( FThreadGroup <> NIL ) then
    AddMe ( FThreadGroup );

end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
constructor TBMDThread.Create ( Owner :TComponent );
begin
  inherited;
  FExecuteThread := NIL;
  FPriority := tpNormal;

  FUpdateTimer := TTimer.Create ( Self );
  FUpdateTimer.Enabled := False;
  FUpdateTimer.OnTimer := OnUpdateTimer;
  FUpdateTimer.Interval := 100;
end;
//---------------------------------------------------------------------------
destructor TBMDThread.Destroy;
begin
  FUpdateTimer.Enabled := False;
  if ( FExecuteThread <> NIL ) then
    begin
    FExecuteThread.OnTerminate := OnThreadTerminateClose;
    FExecuteThread.Terminate ();
    while ( FExecuteThread <> NIL ) do
      Application.ProcessMessages ();
//    FExecuteThread = NIL;
    end;

  FUpdateTimer.Free;
  inherited;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.OnUpdateTimer ( Sender : TObject );
begin
  if ( FExecuteThread = NIL ) then
    exit;

  if ( ThreadGroup <> NIL ) then
    ThreadGroup.ThreadUpdate ( Self, FExecuteThread, FExecuteThread.UpdateData, UpdatePriority, FExecuteThread.PercentProgress );

  if ( Assigned ( OnUpdate )) then
    begin
    UpdateCriticalSection.Enter ();
    OnUpdate ( Self, FExecuteThread, FExecuteThread.UpdateData, FExecuteThread.PercentProgress );
    UpdateCriticalSection.Leave ();
    end;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.Execute();
begin
  if ( Assigned ( OnExecute )) then
    OnExecute ( Self, FExecuteThread, FExecuteThread.UpdateData );

  FInterrupted := FExecuteThread.Terminated;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.OnThreadTerminate ( Sender : TObject  );
begin
  FUpdateTimer.Enabled := False;

  FExecuteThread.Resume ();
  FExecuteThread := NIL;

  ReportTerminated ( ThreadGroup );

  if ( Assigned ( OnTerminate )) then
    begin
    UpdateCriticalSection.Enter ();
    OnTerminate ( Self, Sender as TBMDExecuteThread, (Sender as TBMDExecuteThread ).UpdateData );
    UpdateCriticalSection.Leave ();
    end;

  FUpdateTimer.Enabled := true;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.OnThreadTerminateClose ( Sender : TObject );
begin
  FExecuteThread := NIL;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.ReportStarted ( ThreadGroup :TBMDThreadGroup );
begin
  if ( Runing ) then
    if ( ThreadGroup <> NIL ) then
      ThreadGroup.ThreadStarted ( Self, FExecuteThread, FExecuteThread.UpdateData );
end;
//---------------------------------------------------------------------------
procedure TBMDThread.ReportTerminated ( ThreadGroup :TBMDThreadGroup );
begin
  if ( not Runing ) then
    if ( ThreadGroup <> NIL ) then
      ThreadGroup.ThreadTerminated ( Self, FExecuteThread, FExecuteThread.UpdateData );
end;
//---------------------------------------------------------------------------
procedure TBMDThread.AddMe ( ThreadGroup :TBMDThreadGroup );
begin
  FThreadGroup.AddThread ( Self );
end;
//---------------------------------------------------------------------------
procedure TBMDThread.RemoveMe ( ThreadGroup :TBMDThreadGroup );
begin
  FThreadGroup.RemoveThread ( Self );
end;
//---------------------------------------------------------------------------
procedure TBMDThread.Suspend ();
begin
  if ( FExecuteThread <> NIL ) then
    FExecuteThread.Suspend ();
end;
//---------------------------------------------------------------------------
procedure TBMDThread.Resume ();
begin
  if ( FExecuteThread <> NIL ) then
    FExecuteThread.Resume ();
end;
//---------------------------------------------------------------------------
function TBMDThread.GetTimeInterval () : Cardinal;
begin
  Result := FUpdateTimer.Interval;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.SetTimeInterval ( TimeInterval : Cardinal );
begin
  FUpdateTimer.Interval := TimeInterval;
end;
//---------------------------------------------------------------------------
function TBMDThread.GetRuning () : boolean;
begin
  Result := ( FExecuteThread <> NIL );
end;
//---------------------------------------------------------------------------
procedure TBMDThread.SetPriority ( Value : TThreadPriority );
begin
  FPriority := Value;
  if ( FExecuteThread <> NIL ) then
    FExecuteThread.Priority := Value;

end;
//---------------------------------------------------------------------------
function TBMDThread.GetPriority () : TThreadPriority;
begin
  Result := FPriority;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.Start ( Data : Pointer );
begin
  if ( FExecuteThread <> NIL ) then
    exit;

  FExecuteThread := TBMDExecuteThread.Create ( Self, Data );
  FInterrupted := False;

  ReportStarted ( ThreadGroup );

  if ( Assigned ( OnStart )) then
    begin
    UpdateCriticalSection.Enter ();
    OnStart ( Self, FExecuteThread, FExecuteThread.UpdateData );
    UpdateCriticalSection.Leave ();
    end;

  FExecuteThread.Resume ();
  FUpdateTimer.Enabled := true;
end;
//---------------------------------------------------------------------------
procedure TBMDThread.Start ();
begin
  Start ( NIL );
end;
//---------------------------------------------------------------------------
procedure TBMDThread.Stop (); 
begin
  if ( FExecuteThread <> NIL ) then
    begin
    FExecuteThread.Resume ();
    FExecuteThread.Terminate ();
    end;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
constructor TBMDThreadGroup.Create ( Owner :TComponent );
begin
  inherited;
  FCountRuning := 0;
  OnThreadStart := NIL;
  OnThreadTerminate := NIL;

  ThreadItemsList := TList.Create;
  ThreadsList := TList.Create;
end;

destructor TBMDThreadGroup.Destroy;
begin
  while ( ThreadsCount <> 0 ) do
    Threads [ 0 ].ThreadGroup := NIL;

  ThreadsList.Free;
  ThreadItemsList.Free;
  inherited;
end;

//---------------------------------------------------------------------------
function TBMDThreadGroup.GetRuning () : boolean;
begin
  Result := ( GetCountRuning () > 0 );
end;
//---------------------------------------------------------------------------
function TBMDThreadGroup.GetCountRuning () : Integer;
begin
  UpdateCriticalSection.Enter ();
  Result := FCountRuning;
  UpdateCriticalSection.Leave ();
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.Suspend ();
var
  i : Integer;

begin
    for i := 0 to ThreadItemsCount - 1 do
      ThreadItems [ i ].Suspend ();
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.Resume ();
var
  i : Integer;
  
begin
    for i := 0 to ThreadItemsCount - 1 do
      ThreadItems [ i ].Resume ();
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.AddMe ( ThreadGroup :TBMDThreadGroup );
begin
  FThreadGroup.AddThreadGroup ( Self );
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.RemoveMe ( ThreadGroup :TBMDThreadGroup );
begin
  FThreadGroup.RemoveThreadGroup ( Self );
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.ThreadStarted ( Sender : TObject; Thread : TBMDExecuteThread; var Data : Pointer );
var
  TmpCountRuning : Integer;
begin
//---------------------------------------------------------------------------
// Protected by CriticalSection
  UpdateCriticalSection.Enter ();
  TmpCountRuning := FCountRuning;

  Inc ( FCountRuning );
  if ( Assigned ( OnThreadStart )) then
    OnThreadStart ( Sender, Thread, Data );

  UpdateCriticalSection.Leave ();
//---------------------------------------------------------------------------

  if ( ThreadGroup <> NIL ) then
    ThreadGroup.ThreadStarted ( Sender, Thread, Data );

  if ( TmpCountRuning = 0 ) then
    begin
    if ( Assigned ( OnStart )) then
      OnStart ( Sender, Thread, Data );
    end;

end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.ThreadUpdate ( Sender : TObject; Thread : TBMDExecuteThread; var Data : Pointer; _UpdatePriority : Integer; PercentProgres : Integer );
var
  i       : Integer;
  IntThread  : TBMDThreadBase;
  
begin
  if ( Assigned ( OnThreadUpdate )) then
    OnThreadUpdate ( Sender, Thread, Data, PercentProgres );

  if ( Assigned ( OnUpdate )) then
    begin
    for i := 0 to ThreadItemsCount - 1 do
      begin
      IntThread := ThreadItems [ i ];
      if ( IntThread.Runing ) then
        if ( IntThread.UpdatePriority > _UpdatePriority ) then
          exit;
      end;

    OnUpdate ( Sender, Thread, Data, PercentProgres );
    end;
end;
//---------------------------------------------------------------------------
function TBMDThreadGroup.GetThreadItemsCount () : Integer;
begin
  Result := ThreadItemsList.Count;
end;
//---------------------------------------------------------------------------
function TBMDThreadGroup.GetThreadItems ( Index : Integer ) : TBMDThreadBase;
begin
  Result := TBMDThreadBase (ThreadItemsList.Items [ Index ] );
end;
//---------------------------------------------------------------------------
function TBMDThreadGroup.GetThreadsCount () : Integer;
begin
  Result := ThreadsList.Count;
end;
//---------------------------------------------------------------------------
function TBMDThreadGroup.GetThreads ( Index : Integer ) : TBMDThread;
begin
  Result := TBMDThread ( ThreadsList.Items [ Index ] );
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.ThreadTerminated ( Sender : TObject; Thread : TBMDExecuteThread; var Data : Pointer );
var
  TempCount : Integer;
   
begin
//---------------------------------------------------------------------------
// Protected by CriticalSection
  UpdateCriticalSection.Enter ();

  if ( FCountRuning <> 0 ) then
    Dec ( FCountRuning );

  TempCount := FCountRuning;
  UpdateCriticalSection.Leave ();
//---------------------------------------------------------------------------

  if ( Assigned ( OnThreadTerminate )) then
    OnThreadTerminate ( Sender, Thread, Data );

  if ( ThreadGroup <> NIL ) then
    ThreadGroup.ThreadTerminated ( Sender, Thread, Data );

  if ( TempCount = 0 ) then
    begin
    if ( Assigned ( OnTerminate )) then
      OnTerminate ( Sender, Thread, Data );
    end;

end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.ReportStarted ( ThreadGroup :TBMDThreadGroup ); 
var
  i : Integer;

begin
  if ( ThreadGroup <> NIL ) then
    for i := 0 to ThreadItemsCount - 1 do
      ThreadItems [ i ].ReportStarted ( ThreadGroup );

end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.ReportTerminated ( ThreadGroup :TBMDThreadGroup );
var
  i : Integer;

begin
  if ( ThreadGroup <> NIL ) then
    for i := 0 to ThreadItemsCount - 1 do
      ThreadItems [ i ].ReportTerminated ( ThreadGroup );

end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.Start ();
begin
  Start ( NIL );
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.Start ( Data : Pointer );
var
  i : Integer;

begin
    for i := 0 to ThreadItemsCount - 1 do
      ThreadItems [ i ].Start ( Data );
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.Stop ();
var
  i : Integer;

begin
    for i := 0 to ThreadItemsCount - 1 do
      ThreadItems [ i ].Stop ();
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.AddThread ( _Thread : TBMDThread );
begin
  if ( _Thread.Runing ) then
    _Thread.ReportStarted ( Self );

//---------------------------------------------------------------------------
// Protected by CriticalSection
  UpdateCriticalSection.Enter ();
  ThreadItemsList.Add ( _Thread );
  ThreadsList.Add ( _Thread );
  UpdateCriticalSection.Leave ();
//---------------------------------------------------------------------------
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.AddThreadGroup ( _ThreadGroup : TBMDThreadGroup );
var
  i : Integer;

begin
  if ( _ThreadGroup.Runing ) then
    _ThreadGroup.ReportStarted ( Self );

//---------------------------------------------------------------------------
// Protected by CriticalSection
  UpdateCriticalSection.Enter ();
  ThreadItemsList.Add ( _ThreadGroup );
  for i := 0 to _ThreadGroup.ThreadsCount - 1 do
    ThreadsList.Add ( _ThreadGroup.Threads [ i ] );

  UpdateCriticalSection.Leave ();
//---------------------------------------------------------------------------
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.RemoveThread ( _Thread : TBMDThread );
begin
  if ( _Thread.Runing ) then
    _Thread.ReportTerminated ( Self );

//---------------------------------------------------------------------------
// Protected by CriticalSection
  UpdateCriticalSection.Enter ();
  ThreadItemsList.Remove ( _Thread );
  ThreadsList.Remove ( _Thread );
  UpdateCriticalSection.Leave ();
//---------------------------------------------------------------------------
end;
//---------------------------------------------------------------------------
procedure TBMDThreadGroup.RemoveThreadGroup ( _ThreadGroup : TBMDThreadGroup );
var
  i : Integer;

begin
  if ( _ThreadGroup.Runing ) then
    _ThreadGroup.ReportTerminated ( Self );

//---------------------------------------------------------------------------
// Protected by CriticalSection
  UpdateCriticalSection.Enter ();
  ThreadItemsList.Remove ( _ThreadGroup );
  for i := 0 to _ThreadGroup.ThreadsCount - 1 do
    ThreadsList.Remove ( _ThreadGroup.Threads [ i ] );

  UpdateCriticalSection.Leave ();
//---------------------------------------------------------------------------
end;
//---------------------------------------------------------------------------
function TEmptyEntryPropertyEditor.GetValue: string;
begin
  Result := 'Edit...';
end;
//---------------------------------------------------------------------------
procedure TEmptyEntryPropertyEditor.Edit;
begin
  if ( DesignForm = NIL ) then
    DesignForm := TSynchroMethodsForm.Create ( NIL, Designer );

  DesignForm.SetDesigner ( Designer );

  DesignForm.Show ();
end;
//---------------------------------------------------------------------------
function TEmptyEntryPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [ paDialog, paReadOnly ];
end;
//---------------------------------------------------------------------------
function TBMDThread.GetEmptyEntry () : TPersistent;
begin
  Result := nil;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
function GenerateEventName ( Designer : IFormDesigner; TamplateName : string ) : string;
var
  i              : integer;
  GeneratedName  : string;

begin
  GeneratedName := TamplateName;
  i := 0;

  repeat
    begin
    Inc ( i );
    GeneratedName := TamplateName + IntToStr ( i );
    end;

  until ( not Designer.MethodExists( GeneratedName ));

  Result := GeneratedName;
end;
//---------------------------------------------------------------------------
function GenerateEvent ( Designer : IFormDesigner; TypeID : Pointer; NameTamplate : string  ) : string;
var
  GeneratedName : string;

begin
//  PPropInfo PropInfo = ::GetPropInfo ( __typeinfo(TBMSynchroEventsEditorHelperClass), EventPropertyName );
  GeneratedName := GenerateEventName ( Designer, NameTamplate );
  Designer.CreateMethod( GeneratedName, TypeID );
  Designer.ShowMethod( GeneratedName );

  Result := GeneratedName;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
destructor TBMDThreadControlEditor.Destroy;
begin
  if ( DesignForm <> NIL ) then
    begin
    DesignForm.Free;
    DesignForm := NIL;
    end;
    
  inherited;
end;
//---------------------------------------------------------------------------
procedure TBMDThreadControlEditor.Edit;
begin
  if ( DesignForm = NIL ) then
    DesignForm := TSynchroMethodsForm.Create ( NIL, Designer );

  DesignForm.SetDesigner ( Designer );
  DesignForm.UpdateView ();
  DesignForm.Show ();
end;
//---------------------------------------------------------------------------
procedure TBMDThreadControlEditor.ExecuteVerb ( Index : integer );
begin
  case ( Index ) of
    0: GenerateEvent ( Designer, GetTypeData ( TypeInfo (TBMDThreadSynchroNotifyEvent)), 'SynchroFunc' );

    1: GenerateEvent ( Designer, GetTypeData ( TypeInfo (TBMDThreadSynchroDataNotifyEvent)), 'SynchroFuncData' );

    else Edit ();
  end;

end;
//---------------------------------------------------------------------------
function TBMDThreadControlEditor.GetVerb( Index : integer ) : string;
begin
  case ( Index ) of
    0 : Result := 'New S.M. No Data';
    1 : Result := 'New S.M. + Data';
    else     Result := 'Edit S.M. ...';
  end;
end;
//---------------------------------------------------------------------------
function TBMDThreadControlEditor.GetVerbCount () : integer;
begin
  Result := 3;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
constructor TSynchroMethodsForm.Create(AOwner: TComponent; _Designer : IFormDesigner);
begin
  inherited Create ( AOwner );
  Designer := _Designer;
  UpdateNotifier := TEventsEditorNotification.Create;
  ToolServices.AddNotifierEx ( UpdateNotifier );
  
  UpdateNotifier.FOnFileNotify := OnFileNotify;
  UpdateNotifier.FOnEventNotify := OnEventNotify;

  ThreadEventsList := TStringList.Create;
  StdEventsList := TStringList.Create;

  ValidateComponents;
end;
//---------------------------------------------------------------------------
destructor TSynchroMethodsForm.Destroy;
begin
  ThreadEventsListView.OnChange := NIL;
  StdEventsListView.OnChange := NIL;

  ClearLists;

  StdEventsList.Free;
  ThreadEventsList.Free;
  
  ToolServices.RemoveNotifier ( UpdateNotifier );
  UpdateNotifier.Free;
  inherited;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.PageControlChange(Sender: TObject);
begin
  ValidateComponents;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.ClearLists;
var
  i : integer;

begin
  for i := 0 to ThreadEventsList.Count - 1 do
    ThreadEventsList.Objects [ i ].Free;
//    delete ((TThreadEventSruct *)ThreadEventsList.Objects [ i ] );

  ThreadEventsList.Clear ();
  StdEventsList.Clear ();
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.SetDesigner ( _Designer : IFormDesigner );
begin
  Designer := _Designer;
  if ( Designer <> NIL ) then
    UpdateView ();

end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.OnFileNotify  ( NotifyCode : TFileNotification; const FileName: string; var Cancel : boolean );
begin
  if ( ( NotifyCode = fnProjectClosing ) or ( NotifyCode = fnFileClosing )) then
    begin
    Designer := NIL;
    Hide;
    end

  else
    DesignForm.UpdateView;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.OnEventNotify ( NotifyCode : TEventNotification; var Cancel : boolean );
begin
  DesignForm.UpdateView;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.UpdateView;
var
  OldOnChange : TLVChangeEvent;
  Updated     : boolean;
  i           : integer;
  j           : integer;
  Found       : boolean;
  Item        : TListItem;
  Struct      : TThreadEventSruct;

begin
  if ( Designer = NIL ) then
    Exit;

  ClearLists;

//  if ( PageControl.ActivePage == ThreadSynchroTabSheet )
//  PropInfo := GetPropInfo ( __typeinfo(TBMSynchroEventsEditorHelperClass), "ThreadNotifyEventEmptyEvent" );
  Designer.GetMethods( GetTypeData ( TypeInfo(TBMDThreadSynchroNotifyEvent)), AddMethodNoDataEntry );

//  PropInfo = GetPropInfo ( __typeinfo(TBMSynchroEventsEditorHelperClass), "ThreadDataNotifyEventEmptyEvent" );
  Designer.GetMethods( GetTypeData ( TypeInfo(TBMDThreadSynchroDataNotifyEvent)) , AddMethodDataEntry );


//  PropInfo = ::GetPropInfo ( __typeinfo(TButton), "OnClick" );
  Designer.GetMethods( GetTypeData ( TypeInfo(TNotifyEvent)), AddStandardNotifyEntry );

//  ThreadEventsListView.Items.Clear ();
  OldOnChange := ThreadEventsListView.OnChange;
  ThreadEventsListView.OnChange := NIL;

  Updated := false;

  i := 0;
  while i < ThreadEventsListView.Items.Count do
    begin
    Found := false;
    for j := 0 to ThreadEventsList.Count - 1 do
      begin
      if ( ThreadEventsListView.Items.Item [ i ].Caption = ThreadEventsList.Strings [ j ] ) then
        begin
        if ( ThreadEventsListView.Items.Item [ i ].SubItems.Strings [ 0 ] = TThreadEventSruct ( ThreadEventsList.Objects [ j ]).Parameter ) then
          begin
          Found := true;
//          delete ((TThreadEventSruct *)ThreadEventsList.Objects [ j ]);
          ThreadEventsList.Objects [ j ].Free;
          ThreadEventsList.Delete ( j );
          break;
          end;
        end;
      end;

    if ( not Found ) then
      begin
      if ( not Updated ) then
        ThreadEventsListView.Items.BeginUpdate ();

      Updated := true;
      ThreadEventsListView.Items.Item [ i ].Free;
      Dec ( i );
      end;
    Inc ( i );
    end;

  for i := 0 to ThreadEventsList.Count - 1 do
    begin
    Item := ThreadEventsListView.Items.Add ();
    Item.Caption := ThreadEventsList.Strings [ i ];
    Struct := (ThreadEventsList.Objects [ i ]) as TThreadEventSruct;
    Item.SubItems.Add ( Struct.Parameter     );
    Item.SubItems.Add ( Struct.CallingFormat );
    end;

  ThreadEventsListView.OnChange := OldOnChange;
  if ( Updated ) then
    ThreadEventsListView.Items.EndUpdate ();

  Updated := false;
//  StdEventsListView.Items.Clear ();
  OldOnChange := StdEventsListView.OnChange;
  StdEventsListView.OnChange := NIL;

  i := 0;
  while i < StdEventsListView.Items.Count do
//  for ( int i := 0; i < StdEventsListView.Items.Count; i ++ )
    begin
    Found := false;
    for j := 0 to StdEventsList.Count - 1 do
      begin
      if ( StdEventsListView.Items.Item [ i ].Caption = StdEventsList.Strings [ j ] ) then
        begin
        Found := true;
        StdEventsList.Delete ( j );
        break;
        end;
      end;

    if ( not Found ) then
      begin
      if ( not Updated ) then
        StdEventsListView.Items.BeginUpdate ();
        
      Updated := true;
      StdEventsListView.Items.Item [ i ].Free;
      Dec ( i );
      end;

    Inc ( i );
    end;

  for i := 0 to StdEventsList.Count - 1 do
    begin
    Item := StdEventsListView.Items.Add ();
    Item.Caption := StdEventsList.Strings [ i ];
    Item.SubItems.Add ( 'TObject *Sender' );
    Item.SubItems.Add ( '' );
    end;

  StdEventsListView.OnChange := OldOnChange;
  if ( Updated ) then
    StdEventsListView.Items.EndUpdate ();

  ValidateComponents;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.ValidateComponents;
begin
  if ( PageControl.ActivePage = ThreadSynchroTabSheet ) then
    ActiveListView := ThreadEventsListView

  else
    ActiveListView := StdEventsListView;

  ShowButton1.Enabled := ( ActiveListView.ItemFocused <> NIL );
  ShowButton2.Enabled := ( ActiveListView.ItemFocused <> NIL );
  RenameButton1.Enabled := ShowButton1.Enabled;
  RenameButton2.Enabled := ShowButton1.Enabled;
  GenCallButton1.Enabled := ShowButton1.Enabled;
  GenCallButton2.Enabled := ShowButton1.Enabled;
  CopyCallButton1.Enabled := ShowButton1.Enabled;
  CopyCallButton2.Enabled := ShowButton1.Enabled;
//  CreateGroupBox.Visible := ( TabControl.TabIndex = 0 );
//  RenameButton.Visible := CreateGroupBox.Visible;

  if ( ActiveListView.ItemFocused <> NIL ) then
    StatusBar.SimpleText := 'Thread.Synchronize ( ' + ActiveListView.ItemFocused.Caption + ActiveListView.ItemFocused.SubItems.Strings [ 1 ] + ' );'

  else
    StatusBar.SimpleText := '';
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.RefreshButton1Click(Sender: TObject);
begin
  UpdateView ();
end;

//---------------------------------------------------------------------------

procedure TSynchroMethodsForm.BtnNoDataEventClick(Sender: TObject);
begin
  if ( Designer = NIL ) then
    Exit;

  AddMethodNoDataItem ( GenerateEvent ( Designer, GetTypeData ( TypeInfo (TBMDThreadSynchroNotifyEvent)), 'SynchroFunc' ) ).EditCaption();
  FormResize ( Sender );
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.BtnDataEventClick(Sender: TObject);
begin
  if ( Designer = NIL ) then
    Exit;

  AddMethodDataItem ( GenerateEvent ( Designer, GetTypeData ( TypeInfo ( TBMDThreadSynchroDataNotifyEvent )), 'SynchroFuncData' ) ).EditCaption();
  FormResize( Sender );
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.RenameButton1Click(Sender: TObject);
begin
  if ( ActiveListView.ItemFocused <> NIL ) then
    begin
    ActiveListView.ItemFocused.EditCaption();
    end;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.ShowButton1Click(Sender: TObject);
begin
  if ( Designer = NIL ) then
    Exit;
    
  if ( ActiveListView.ItemFocused <> NIL ) then
    begin
    Designer.ShowMethod ( ActiveListView.ItemFocused.Caption );
    end;

  Show ();
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.CopyCallButton1Click(Sender: TObject);
begin
  Clipboard.AsText := StatusBar.SimpleText;
end;
//---------------------------------------------------------------------------
function GetCurrentEditView(EditorIntf: TIEditorInterface): Integer;
var
  EditorFileName: string;
  WindowIterator: HWND;
  Buffer: array[0..255] of Char;
  APos: PChar;
begin
  Assert(EditorIntf <> nil);
  Result := -1;
  if EditorIntf.GetViewCount = 1 then
  begin
    // If there is only one edit view, then it is clear that
    // the first one is the current edit view
    Result := 0;
  end
  else
  begin
    EditorFileName := UpperCase(ExtractFileName(EditorIntf.FileName));
    WindowIterator := GetWindow(GetDesktopWindow, GW_CHILD);
    // Iterate over all windows whose owner is the Desktop
    WindowIterator := GetWindow(WindowIterator, GW_HWNDNEXT);

    // If we find a window with the class name "TEditWindow"
    // and the filenames match then this is the currently active
    // edit view
    while (WindowIterator <> 0) and IsWindow(WindowIterator) do
    begin
      if GetClassName(WindowIterator, Buffer, SizeOf(Buffer) - 1) = 0 then
        RaiseLastWin32Error;
      if StrPos(Buffer, 'TEditWindow') <> nil then
      begin
        if GetWindowText(WindowIterator, Buffer, SizeOf(Buffer) - 1) = 0 then
          RaiseLastWin32Error;
        StrUpper(Buffer);
        if StrPos(Buffer, PChar(EditorFileName)) <> nil then
        begin
          // I the case where there are multiple edit windows
          // open the first one you come to in the iteration process
          // should always be the top-most (or most recently active) edit
          // window - JCH
          // Scan window caption from the end; if we started at the
          // beginning, we might run into the colon of C:\MyFile
          APos := StrRScan(Buffer, ':');
          Inc(APos);
          Result := StrToIntDef(StrPas(APos), -1);
          // Subtract 1 since we need 0..GetViewCount-1 rather than 1..GetViewCount
          if Result <> -1 then
            Dec(Result);
          Break;
        end;
      end;
      WindowIterator := GetWindow(WindowIterator, GW_HWNDNEXT);
    end;
  end;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.GenCallButton1Click(Sender: TObject);
var
  ModIntf       : TIModuleInterface;
  EditorIntf    : TIEditorInterface;
  CurrentView   : integer;
  View          : TIEditView;
  CharPos       : TCharPos;
  EditPos       : TEditPos;
  OldBlockType  : TBlockType;
  Writer        : TIEditWriter;
  i             : integer;

begin
  ModIntf := ToolServices.GetModuleInterface ( ToolServices.GetCurrentFile () );
  if ( ModIntf = NIL ) then
    begin
    ShowMessage (
      'Please select the editor bofore pressing this button.'#13+
      'For now the code will go to the clipboard.'#13+
      'You can paste wherever you want.'
     );

    Clipboard().AsText := StatusBar.SimpleText;
    end

  else
    begin
    ModIntf.ShowSource ();
    EditorIntf := ModIntf.GetEditorInterface ();
    if ( EditorIntf <> NIL ) then
      begin
      if ( EditorIntf.GetViewCount () > 0 ) then
        begin
        CurrentView := GetCurrentEditView ( EditorIntf );
        View := EditorIntf.GetView ( CurrentView );
        if ( View <> NIL ) then
          begin
          try
            begin
            EditPos := View.CursorPos;
            View.ConvertPos ( true, EditPos, CharPos );
            OldBlockType := EditorIntf.BlockType;
            EditorIntf.BlockType := btInclusive;
            EditorIntf.BlockStart := CharPos;
            EditorIntf.BlockAfter := CharPos;
            EditorIntf.BlockVisible := true;

            if ( MessageDlg ( 'Insert the code at this location ?', mtConfirmation , [ mbYes, mbNo ], 0 ) = mrYes ) then
              begin
              Writer := EditorIntf.CreateUndoableWriter ();
              try
                begin
                Writer.CopyTo ( View.CharPosToPos ( CharPos ));
                if ( ( CharPos.CharIndex = 0 ) and ( EditPos.Col > 0 )) then
                  for i := 0 to EditPos.Col - 2 do
                    Writer.Insert ( ' ' );

                Writer.Insert ( PChar ( StatusBar.SimpleText ) );
                Writer.Insert ( #13#10 );
                for i := 0 to EditPos.Col - 1 do
                  Writer.Insert ( ' ' );

                Writer.CopyTo ( MaxLongint );
                end;

              finally
                Writer.Free ();
                
              end;

              ModIntf.ShowSource ();
              Inc ( EditPos.Line );
              View.CursorPos := EditPos;
              end;

            EditorIntf.BlockType := OldBlockType;
            EditorIntf.BlockStart := CharPos;
            EditorIntf.BlockAfter := CharPos;
            EditorIntf.BlockVisible := false;
            end;

          except;
          end;

          View.Free ();
          end;
        end;

      EditorIntf.Free ();
      end;

    ModIntf.Free ();
    end;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.NewStdButtonClick(Sender: TObject);
begin
  if ( Designer = NIL ) then
    Exit;

  AddStandardNotifyItem ( GenerateEvent ( Designer, GetTypeData ( TypeInfo ( TNotifyEvent )), 'NotifyEvent' ) ).EditCaption();
  FormResize( Sender );
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.ThreadEventsListViewChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
  ValidateComponents ();
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.ThreadEventsListViewEdited(Sender: TObject;
  Item: TListItem; var S: String);
begin
  if ( Designer = NIL ) then
    Exit;

  if ( Item.Caption <> S ) then
    begin
    if ( Designer.MethodExists( S )) then
      begin
      S := GenerateEventName ( Designer, S );
      end;

    Designer.RenameMethod ( Item.Caption, S );
    end;

end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.ThreadEventsListViewKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ( ( Key = #13 ) or ( Key = ' ' )) then
    ShowButton1Click ( Sender );

end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.FormResize(Sender: TObject);
begin
  ThreadEventsListView.Column [ 1 ].Width := ThreadEventsListView.ClientWidth - ThreadEventsListView.Column [ 0 ].Width;
  StdEventsListView.Column [ 1 ].Width := StdEventsListView.ClientWidth - StdEventsListView.Column [ 0 ].Width;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.FormShow(Sender: TObject);
begin
  FormResize( Sender );
  ValidateComponents;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.AddMethodNoDataEntry ( const S: string );
var
  Struct : TThreadEventSruct;
begin
  Struct := TThreadEventSruct.Create;
  Struct.Parameter := 'Thread : TBMExecuteThread';
  ThreadEventsList.AddObject ( S, Struct );
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.AddMethodDataEntry ( const S: string );
var
  Struct : TThreadEventSruct;

begin
  Struct := TThreadEventSruct.Create;
  Struct.Parameter := 'Thread : TBMExecuteThread; var Data : Pointer';
  Struct.CallingFormat := ', [%Data to pass here]';
  ThreadEventsList.AddObject ( S, Struct );
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.AddStandardNotifyEntry ( const S: string );
begin
  StdEventsList.Add ( S );
end;
//---------------------------------------------------------------------------
function TSynchroMethodsForm.AddMethodNoDataItem ( const S: string ) : TListItem;
var
  Item : TListItem;
begin
  Item := ThreadEventsListView.Items.Add ();
  Item.Caption := S;
  Item.SubItems.Add ( 'Thread : TBMExecuteThread' );
  Item.SubItems.Add ( '' );

  Result := Item;
end;
//---------------------------------------------------------------------------
function TSynchroMethodsForm.AddMethodDataItem ( const S: string ) : TListItem;
var
  Item : TListItem;
begin
  Item := ThreadEventsListView.Items.Add ();
  Item.Caption := S;
  Item.SubItems.Add ( 'Thread : TBMExecuteThread; var Data : Pointer' );
  Item.SubItems.Add ( ', & [%Data to pass here]' );

  Result := Item;
end;
//---------------------------------------------------------------------------
function TSynchroMethodsForm.AddStandardNotifyItem ( const S: string ) : TListItem;
var
  Item : TListItem;
begin
  Item := StdEventsListView.Items.Add ();
  Item.Caption := S;
  Item.SubItems.Add ( 'Sender : TObject' );
  Item.SubItems.Add ( '' );

  Result := Item;
end;
//---------------------------------------------------------------------------
procedure TSynchroMethodsForm.Timer1Timer(Sender: TObject);
begin
  UpdateView;
  ValidateComponents;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

procedure Register;
begin
  RegisterComponents('BMitov', [TBMDThread, TBMDThreadGroup]);
  RegisterPropertyEditor(TypeInfo(TPersistent), TBMDThread, 'SynchroMethods', TEmptyEntryPropertyEditor);
  RegisterComponentEditor(TBMDThread, TBMDThreadControlEditor);
end;

initialization
  DesignForm := NIL;

finalization
  if ( DesignForm <> NIL ) then
    begin
    DesignForm.Free;
    DesignForm := NIL;
    end;


end.
